var utilObj = (function() {

    // 获取appid
    var getAppid = function() {
        return "wx752d073baf38fbf3";
    };

    //sessionstorage存储
    var sessionstorage = (function() {

        var get = function(key) {
            // if(typeof(sessionStorage.getItem(key)) == 'string'){
            //     return sessionStorage.getItem(key);
            // }else{
            //     return JSON.parse(sessionStorage.getItem(key));
            // }
            return JSON.parse(sessionStorage.getItem(key));
        }

        var set = function(key, value) {
            sessionStorage.setItem(key, JSON.stringify(value));
        }

        var remove = function(key) {
            sessionStorage.removeItem(key);
        }

        var clear = function() {
            sessionStorage.clear();
        }
        return {
            set: set,
            get: get,
            remove: remove,
            clear: clear
        }
    })()
    //获取url?后面的参数
    var getUrlparam = function() {
        let _url = window.location.href.split("?")[1];
        let _obj = {};
        console.log(_url);
        if (_url != "" && _url != null) {
            if (_url.indexOf("=") > -1) {
                if (_url.indexOf("&") > -1) {
                    let a = _url.split("&");
                    for (let i = 0; i < a.length; i++) {
                        let b = a[i].split("=");
                        _obj[b[0]] = b[1];
                    }
                    return _obj;
                } else {
                    let a = _url.split("=");
                    _obj[a[0]] = a[1];
                    return _obj;
                }
            } else {
                _obj[_url] = _url;
                return _obj;
            }
        } else {
            return _obj;
        }

    }
    //字符串转unicode
    var strForUnicode = function(str) {
        let val = "";
        for (let i = 0; i < str.length; i++) {
            if (val == "") {
                val = str.charCodeAt(i)
            } else {
                val += "," + str.charCodeAt(i)
            }　
        }
        return val;
    }
    //unicode转字符串
    var unicodeForStr = function(str) {
        let _arr = str.split(",");
        let val = "";
        for (let i = 0; i < _arr.length; i++) {
            val += String.fromCharCode(arr[i]);
        }
        return val;
    }
    //验证日期合法性
    var checkDate = function(str, validateEmpty) {

        var result = {
            code: 0,
            msg: '',
            date: null
        };

        var map = {
            '-1': '年份超出范围',
            '-2': '月份超出范围',
            '-3': '日期超出范围',
            '-4': '日期格式不正确，正确格式是 YYYY-MM-DD',
            '-5': '日期格式不正确，正确格式是 YYYY-MM-DD',
            '-6': '日期不能为空'
        };

        function setResult(code) {
            result.code = code;
            result.msg = map[code];
        }

        if (str == "") {
            if (validateEmpty == true) setResult(-6);
            return result;
        }

        var year, month, date;

        if (/^\d{4}-\d{2}-\d{2}$/gi.test(str) == false) {
            setResult(-4);
            return result;
        } else {
            if (new Date(str) == "Invalid Date") {
                setResult(-5);
                return result;
            } else {
                var date = new Date(str.replaceAll('-', '/'));
                year = date.getFullYear();
                month = date.getMonth() + 1;
                date = date.getDate();
            }
        }

        year = parseInt(year, 10);
        month = parseInt(month, 10);
        date = parseInt(date, 10);

        if (year < 1900 || year > 3000) {
            setResult(-1);
            return result;
        }

        if (month < 1 || month > 12) {
            setResult(-2);
            return result;
        }

        var getDate = function(month) {
            if (month == 1 || month == 3 || month == 5 || month == 7 || month == 8 || month == 10 || month == 12) {
                return 31;
            } else if (month == 4 || month == 6 || month == 9 || month == 11) {
                return 30;
            } else if (month == 2) {
                return ((year % 4 == 0) && (year % 100 != 0 || year % 400 == 0)) ? 29 : 28;
            }
            return 0;
        }

        if (date < 1 || date > getDate(month)) {
            setResult(-3);
            return result;
        }

        result.date = new Date(year, month - 1, date).format();

        return result;
    }
    //验证身份证
    var verifyCard = function(number) {
        var result = {
            code: 0,
            msg: '',
            date: null
        };

        var vcity = {
            11: "北京",
            12: "天津",
            13: "河北",
            14: "山西",
            15: "内蒙古",
            21: "辽宁",
            22: "吉林",
            23: "黑龙江",
            31: "上海",
            32: "江苏",
            33: "浙江",
            34: "安徽",
            35: "福建",
            36: "江西",
            37: "山东",
            41: "河南",
            42: "湖北",
            43: "湖南",
            44: "广东",
            45: "广西",
            46: "海南",
            50: "重庆",
            51: "四川",
            52: "贵州",
            53: "云南",
            54: "西藏",
            61: "陕西",
            62: "甘肃",
            63: "青海",
            64: "宁夏",
            65: "新疆",
            71: "台湾",
            81: "香港",
            82: "澳门",
            91: "国外"
        };

        var map = {
            '-1': '证件号不能为空',
            '-2': '身份证号码只能是15位或者18位，15位只能是数字，18位只能是数字或者大写字母X',
            '-3': '前两位号码省份校验出错，请输入正确的身份证号码',
            '-4': '身份证中的出生日期不正确，请重新输入',
            '-5': '身份证校验位不正确，请重新输入'
        };

        function setResult(code) {
            result.code = code;
            result.msg = map[code];
        }

        //校验是否为空
        if (number == "") {
            setResult(-1);
            return result;
        }

        //校验长度
        if (!/(^\d{15}$)|(^\d{17}(\d|X)$)/.test(number)) {
            setResult(-2);
            return result;
        }

        //校验省份编码
        if (typeof(vcity[number.substring(0, 2)]) == "undefined") {
            setResult(-3);
            return result;
        }

        //校验生日
        if (number.length == 15) {
            var re_fifteen = /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/;
            var arr_data = number.match(re_fifteen);
            var year = arr_data[2];
            var month = arr_data[3];
            var day = arr_data[4];
            var validate = checkDate([year, month, day].join("-"));
            if (validate.code != 0) {
                setResult(-4);
                return result;
            }

            result.date = validate.date;
        }

        if (number.length == 18) {
            var re_eighteen = /^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/;
            var arr_data = number.match(re_eighteen);
            var year = arr_data[2];
            var month = arr_data[3];
            var day = arr_data[4];
            var validate = checkDate([year, month, day].join('-'));
            if (validate.code != 0) {
                setResult(-4);
                return result;
            }
            result.date = validate.date;

            //18位身份证校验位校验
            var Wi = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2, 1); //权值

            var Ai = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2'); //校验结果匹配

            if (number.charAt(17) == 'x') {
                number = number.replace("x", "X");
            }

            var checkDigit = number.charAt(17);
            var cardNoSum = 0;

            for (var i = 0; i < number.length - 1; i++) {
                cardNoSum = cardNoSum + number.charAt(i) * Wi[i];
            }

            var seq = cardNoSum % 11;
            var getCheckDigit = Ai[seq];

            if (checkDigit != getCheckDigit) {
                setResult(-5);
                return result;
            }
        }

        return result;
    }
    //获取身份证中的生日日期
    var getBirthday = function(number) {

        if (number.length == 15) {
            var re_fifteen = /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/;
            var arr_data = number.match(re_fifteen);
            var year = arr_data[2];
            var month = arr_data[3];
            var day = arr_data[4];
            var validate = checkDate([year, month, day].join("-"));
            if (validate.code == 0) {
                return [year, month, day].join("-");
            }
        }

        if (number.length == 18) {
            var re_eighteen = /^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/;
            var arr_data = number.match(re_eighteen);
            var year = arr_data[2];
            var month = arr_data[3];
            var day = arr_data[4];
            var validate = checkDate([year, month, day].join('-'));
            if (validate.code == 0) {
                return [year, month, day].join('-');
            }
        }
    }
    // 非法字符安全检查
    var checkSpecialChar = function(param) {
        var regText = / and | exec | count | chr | mid | master | or | truncate | char | declare | join |insert|delete|update|create|drop|<|>|\/\*|\*\/|'|\||;|\$|"|\\'|\\"|\\|\(\)|\+|,|0x0d|0x0a/i;


        // 存在非法字符返回0，否则返回1
        if (regText.test(param)) {
            return 0;
        } else {
            return 1;
        }

    }
    // 检查手机号合法性
    var checkPhone = function(number) {
        var reg = /^1[3|4|5|7|8|9][0-9]\d{8}$/;
        if (reg.test(number)) {
            return 1;
        } else {
            return 0;
        }
    }
    return {
        getAppid: getAppid,
        getImei: getImei,
        strForUnicode: strForUnicode,
        unicodeForStr: unicodeForStr,
        verifyCard: verifyCard,
        checkDate: checkDate,
        getBirthday: getBirthday,
        sessionstorage: sessionstorage,
        getUrlparam: getUrlparam,
        checkSpecialChar: checkSpecialChar,
        checkPhone: checkPhone
    }
})();


export default utilObj
// exports.strForUnicode = strForUnicode;
// exports.unicodeForStr = unicodeForStr;
// exports.verifyCard = verifyCard;
// exports.checkDate = checkDate;
// exports.getBirthday = getBirthday;
// exports.sessionstorage = sessionstorage;
// exports.getUrlparam = getUrlparam;